use crate::HashMap;
use core::num::{NonZeroU32, NonZeroUsize};
use core::time::Duration;

use alloc::string::String;

extern crate serde;

#[derive(serde::Deserialize, Clone)]
pub struct Config {
    pub master: Option<String>,
    pub author: Option<String>,
    pub primary_channel: Option<String>,
    pub http_connect_timeout: Option<Duration>,
    pub hosts: HashMap<String, CService>,
    pub throttling: Option<Throttling>,
}

#[derive(serde::Deserialize, Clone, Copy)]
pub struct Throttling {
    pub max_messages: NonZeroU32,
    pub window: NonZeroUsize,
}

#[derive(serde::Deserialize, Clone)]
pub struct CService {
    pub url: String,
    pub username: String,
    pub password: Option<String>,
    pub password_file: Option<String>,
}
